;******************************************************************************************************************
;
;  								              C64 Framework V1.0
;
;									                 By 
;
;									            Mike Dailly 
;  								            (c) Copyright 2008
;                                          All Rights Reserved
;
;                                             mike@dailly.org
;	
; Terms of use:
;
;		This Source Code is given away free and you may do anything you like with it except
;		sell it. You should also seriously consider releasing the source to any game or application 
;		that uses any part of this program. Any new feature, addition or enhancement to any part of 
;		the framework must have its source code released for all to use. Such additions must also be 
;		be sent directly to me for possibly inclusion of the framework.
;
;		Credit must also be given to the original authors if any part of this source is used.
;
;		     Michael Dailly retains copyright of this program and its source+assets.
;
;
;	This program and its source were made to further the retro comunity, and breaking any of these conditions
;	renders all the years of work meaningless. So have fun with it, and then let others have fun with your work too!
;
;
;******************************************************************************************************************
CurrentAddress:

			;
			; Make some sprites
			;
			org	EmptySprite
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0

colourfill	equ	%10101010
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill

colourfill5	equ	%01010101
colourfill2	equ	%10101010
colourfill3	equ	%01101010
colourfill4	equ	%10101001
			db	colourfill5, colourfill5, colourfill5
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4			; Make the player a little different
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill5, colourfill5, colourfill5



			org	CurrentAddress

;*******************************************************************************
;
; Screen tables.
;
;*******************************************************************************
one_line	equ	40	 			; amount to add to get 1 line down
SCROFFSET	equ	0
GAdd_LO2:	db	0,Lo((one_Line*1)),Lo((one_Line*2)),Lo((one_Line*3)),Lo((one_Line*4))
			db	Lo((one_Line*5)),Lo((one_Line*6)),Lo((one_Line*7)),Lo((one_Line*8))
			db	Lo((one_Line*9)),Lo((one_Line*10)),Lo((one_Line*11)),Lo((one_Line*12))
			db	Lo((one_Line*13)),Lo((one_Line*14)),Lo((one_Line*15)),Lo((one_Line*16))
			db	Lo((one_Line*17)),Lo((one_Line*18)),Lo((one_Line*19)),Lo((one_Line*20))
			db	Lo((one_Line*21)),Lo((one_Line*22)),Lo((one_Line*23)),Lo((one_Line*24))

GAdd_HI2:	db	Hi(0+SCROFFSET),Hi((one_Line*1)+SCROFFSET),Hi((one_Line*2)+SCROFFSET),Hi((one_Line*3)+SCROFFSET),Hi((one_Line*4)+SCROFFSET)
			db	Hi((one_Line*5)+SCROFFSET),Hi((one_Line*6)+SCROFFSET),Hi((one_Line*7)+SCROFFSET),Hi((one_Line*8)+SCROFFSET)
			db	Hi((one_Line*9)+SCROFFSET),Hi((one_Line*10)+SCROFFSET),Hi((one_Line*11)+SCROFFSET),Hi((one_Line*12)+SCROFFSET)
			db	Hi((one_Line*13)+SCROFFSET),Hi((one_Line*14)+SCROFFSET),Hi((one_Line*15)+SCROFFSET),Hi((one_Line*16)+SCROFFSET)
			db	Hi((one_Line*17)+SCROFFSET),Hi((one_Line*18)+SCROFFSET),Hi((one_Line*19)+SCROFFSET),Hi((one_Line*20)+SCROFFSET)
			db	Hi((one_Line*21)+SCROFFSET),Hi((one_Line*22)+SCROFFSET),Hi((one_Line*23)+SCROFFSET),Hi((one_Line*24)+SCROFFSET)


;*******************************************************************************
; MMC filenames
;*******************************************************************************
;TestFile			db	"SYSTEM64\D64PLGIN.BIN",0
;TestFile			db	"SYSTEM64\SCREEN11.TXT",0
;TestFile			db	"TEST\TEST2\TEST3\SCREEN.TXT",0
;TestFile			db	"TEST\TEST2\TEST3\SCREEN",0
;TestFile			db	"TESTPRG1.PRG",0
;TestFile			db	"TEST2.PRG",0

;*******************************************************************************
;
; Sprite speed values and temp colours
;
;*******************************************************************************
SpriteSpeedsY
			db	-3,4,-5,-2,1,3,-1,7,-3,-2,-1,-3,2,8,4,-8
			db	5,1,3,4,-1,-2,3,4,-1,-2,3,-4,1,-2,3,-4
			db	-3,4,1,-2,-4,3,-1,3,-4,1,-2,-3,2,1,4,2
			db	3,4,-1,-2,3,4,-1,-2,3,-4,1,-2,3,4,2,1

SpriteSpeeds
			db	-1,1,1,-3,2,-4,1,-2,-3,1,1,-2,3,-4,-1,2
			db	4,3,-1,2,3,-4,1,-2,-3,4,1,-2,3,-4,-1,2
			db	-3,-1,2,3,-4,1,-2,-3,4,1,-2,3,-4,-1,2,3
			db	4,3,-1,2,3,-4,1,-2,-3,4,1,-2,3,-4,-1,2
SpriteSpeedsHi
			db	$ff,0,0,$ff,0,$ff,0,$ff,$ff,0,0,$ff,0,$ff,$ff,0
			db	0,0,$ff,0,0,$ff,0,$ff,$ff,0,0,$ff,0,$ff,$ff,0
			db	$ff,$ff,0,0,$ff,0,$ff,$ff,0,0,$ff,0,$ff,$ff,0,0,0
			db	0,0,$ff,0,0,$ff,0,$ff,$ff,0,0,$ff,0,$ff,$ff,0

TempSpriteColours:
			db	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
			db	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
			db	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
			db	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15



;*******************************************************************************
;
; Data allocation
;
;*******************************************************************************
StartOfData
AllocAddr		set	StartOfData              ; set base address of general data allocation

				Alloc	FrameCounter,1

; Multiplexor IRQ stuff
				Alloc	IRQ_SpriteY,MaxSprites+1			; 
				Alloc	IRQ_SpriteX,MaxSprites		; -1 for master path, and *2 for double buffer
				Alloc	IRQ_SpriteSig,MaxSprites		; -1 for master path, and *2 for double buffer
				Alloc	IRQ_SpriteCol,MaxSprites		; -1 for master path, and *2 for double buffer
				Alloc	IRQ_SpriteShape,MaxSprites		; -1 for master path, and *2 for double buffer

; Sprite Data
				Alloc	SpxLo,MaxSprites			; SpriteX 
				Alloc	SpxHi,MaxSprites			; Sprite Sig bit
				Alloc	SpShape,MaxSprites			; Sprite SHAPE
				Alloc	SpCol,MaxSprites			; Sprite colour


; Initialisation stuff
				Alloc	SpriteSpacing,1
				Alloc	SpriteSpacingx,1

; Collision stuff
				Alloc	CenterXoffset,MaxSprites	; /2 so we dont have to deal with the sig bit
				Alloc	CenterYoffset,MaxSprites	
				Alloc	RadX,MaxSprites
				Alloc	RadY,MaxSprites
; Animation stuff
				Alloc	AnimDelay,MaxSprites+1
				Alloc	AnimLo,MaxSprites+1
				Alloc	AnimHi,MaxSprites+1
				Alloc	AnimFrame,MaxSprites+1


				org	AllocAddr
				Message	"End Low Data=", *

EndOfCodeAddress




