;*******************************************************************************
;
; Misc stuff
;
;*******************************************************************************
CurrentAddress:
			;
			; Make some sprites
			;
			org	EmptySprite
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0

			incbin	"bomb2.spr"

			;
			; Player is a 16x16 sprite
			;
colourfill	equ	%10101010
			db	colourfill, colourfill, 0, colourfill, colourfill, 0, colourfill, colourfill
			db	0, colourfill, colourfill, 0, colourfill, colourfill, 0, colourfill
			db	colourfill, 0, colourfill, colourfill, 0, colourfill, colourfill, 0
			db	colourfill, colourfill, 0, colourfill, colourfill, 0, colourfill, colourfill
			db	0, colourfill, colourfill, 0, colourfill, colourfill, 0, colourfill
			db	colourfill, 0, colourfill, colourfill, 0, colourfill, colourfill, 0
			db	0,0,0,0,0,0,0,0
			db	0,0,0,0,0,0,0,0
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill
			db	colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill, colourfill

			;incbin	"bomb.sprite"
			incbin	"bomb2.spr"

colourfill5	equ	%01010101
colourfill2	equ	%10101010
colourfill3	equ	%01101010
colourfill4	equ	%10101001
			db	colourfill5, colourfill5, colourfill5
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4			; Make the player a little different
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill3, colourfill2, colourfill4
			db	colourfill5, colourfill5, colourfill5

			; Compressed Ballistix picture
			org	$8000
			incprg	"picture.prg"


			org	CurrentAddress

;*******************************************************************************
;
; Screen tables.
;
;*******************************************************************************
one_line	equ	40	 			; amount to add to get 1 line down
SCROFFSET	equ	0
GAdd_LO2:	db	0,Lo((one_Line*1)),Lo((one_Line*2)),Lo((one_Line*3)),Lo((one_Line*4))
			db	Lo((one_Line*5)),Lo((one_Line*6)),Lo((one_Line*7)),Lo((one_Line*8))
			db	Lo((one_Line*9)),Lo((one_Line*10)),Lo((one_Line*11)),Lo((one_Line*12))
			db	Lo((one_Line*13)),Lo((one_Line*14)),Lo((one_Line*15)),Lo((one_Line*16))
			db	Lo((one_Line*17)),Lo((one_Line*18)),Lo((one_Line*19)),Lo((one_Line*20))
			db	Lo((one_Line*21)),Lo((one_Line*22)),Lo((one_Line*23)),Lo((one_Line*24))

GAdd_HI2:	db	Hi(0+SCROFFSET),Hi((one_Line*1)+SCROFFSET),Hi((one_Line*2)+SCROFFSET),Hi((one_Line*3)+SCROFFSET),Hi((one_Line*4)+SCROFFSET)
			db	Hi((one_Line*5)+SCROFFSET),Hi((one_Line*6)+SCROFFSET),Hi((one_Line*7)+SCROFFSET),Hi((one_Line*8)+SCROFFSET)
			db	Hi((one_Line*9)+SCROFFSET),Hi((one_Line*10)+SCROFFSET),Hi((one_Line*11)+SCROFFSET),Hi((one_Line*12)+SCROFFSET)
			db	Hi((one_Line*13)+SCROFFSET),Hi((one_Line*14)+SCROFFSET),Hi((one_Line*15)+SCROFFSET),Hi((one_Line*16)+SCROFFSET)
			db	Hi((one_Line*17)+SCROFFSET),Hi((one_Line*18)+SCROFFSET),Hi((one_Line*19)+SCROFFSET),Hi((one_Line*20)+SCROFFSET)
			db	Hi((one_Line*21)+SCROFFSET),Hi((one_Line*22)+SCROFFSET),Hi((one_Line*23)+SCROFFSET),Hi((one_Line*24)+SCROFFSET)


;*******************************************************************************
;
;
;
;*******************************************************************************


;*******************************************************************************
;
; Data allocation
;
;*******************************************************************************
StartOfData
AllocAddr		set	StartOfData              ; set base address of general data allocation

				Alloc	FrameCounter,1

; Multiplexor IRQ stuff
				Alloc	IRQ_SpriteY,MaxSprites+1			; 
				Alloc	IRQ_SpriteX,MaxSprites		; -1 for master path, and *2 for double buffer
				Alloc	IRQ_SpriteSig,MaxSprites		; -1 for master path, and *2 for double buffer
				Alloc	IRQ_SpriteCol,MaxSprites		; -1 for master path, and *2 for double buffer
				Alloc	IRQ_SpriteShape,MaxSprites		; -1 for master path, and *2 for double buffer

; Sprite Data
				Alloc	SpxLo,MaxSprites			; SpriteX 
				Alloc	SpxHi,MaxSprites			; Sprite Sig bit
				Alloc	SpShape,MaxSprites			; Sprite SHAPE
				Alloc	SpCol,MaxSprites			; Sprite colour


; Initialisation stuff
				Alloc	SpriteSpacing,1
				Alloc	SpriteSpacingx,1

; Collision stuff
				Alloc	CenterXoffset,MaxSprites	; /2 so we dont have to deal with the sig bit
				Alloc	CenterYoffset,MaxSprites	
				Alloc	RadX,MaxSprites
				Alloc	RadY,MaxSprites

; Level stuff
				Alloc	LevelNumber,1

; Animation stuff
				Alloc	AnimDelay,MaxSprites+1
				Alloc	AnimLo,MaxSprites+1
				Alloc	AnimHi,MaxSprites+1
				Alloc	AnimFrame,MaxSprites+1

				org	AllocAddr
				Message	"End Low Data=", *

EndOfCodeAddress




