;-----------------------------------------------------------------------------
;			KEY MAP LABLES
;			by Mike Dailly
;
;
; These values are Written to $DC00 and Read from $DC01.
; ie. to read the DEL key
;
;	lda	#write_del
;	sta	$DC00
;	lda	$DC01
;	cmp	#read_del
;	beq	DEL_HIT
;	:
;	:etc..
;	:
;	:


;-- FIRST WRITE VALUES --	


;row #1
write_del			=	$fe
write_return		=	$fe
write_cur_right		=	$fe
write_f7			=	$fe
write_f1			=	$fe
write_f3			=	$fe
write_f5			=	$fe
write_cur_down		=	$fe
	
;row #2
write_3				=	$fd
write_w				=	$fd
write_a				=	$fd
write_4				=	$fd
write_z				=	$fd
write_s				=	$fd
write_e				=	$fd
write_left_shift	=	$fd

;row #3
write_5				=	$fb
write_r				=	$fb
write_d				=	$fb
write_6				=	$fb
write_c				=	$fb
write_f				=	$fb
write_t				=	$fb
write_x				=	$fb

;row #4
write_7				=	$f7
write_y				=	$f7
write_g				=	$f7
write_8				=	$f7
write_b				=	$f7
write_h				=	$f7
write_u				=	$f7
write_v				=	$f7

;row #5
write_9				=	$ef
write_i				=	$ef
write_j				=	$ef
write_0				=	$ef
write_m				=	$ef
write_k				=	$ef
write_o				=	$ef
write_n				=	$ef

;row #6
write_plus			=	$df
write_p				=	$df
write_l				=	$df
write_minus			=	$df
write_full_stop		=	$df
write_colon			=	$df
write_at			=	$df
write_coma			=	$df

;row #7
write_pound			=	$bf
write_star			=	$bf
write_semi_colon	=	$bf
write_clr_home		=	$bf
write_right_shift 	=	$bf
write_equal			=	$bf
write_arrow_up		=	$bf
write_divide		=	$bf

;row #8
write_1				=	$7f
write_arrow_left	=	$7f
write_control		=	$7f
write_2				=	$7f
write_space			=	$7f
write_cbm			=	$7f
write_q				=	$7f
write_STOP			=	$7f



;-- NOW READ VALUES --

;row #1
read_del			=	~$fe
read_return			=	~$fd
read_cur_right		=	~$fb
read_f7				=	~$f7
read_f1				=	~$ef
read_f3				=	~$df
read_f5				=	~$bf
read_cur_down		=	~$7f

;row #2
read_3				=	~$fe
read_w				=	~$fd
read_a				=	~$fb
read_4				=	~$f7
read_z				=	~$ef
read_s				=	~$df
read_e				=	~$bf
read_left_shift		=	~$7f
						
;row #3
read_5				=	~$fe
read_r				=	~$fd
read_d				=	~$fb
read_6				=	~$f7
read_c				=	~$ef
read_f				=	~$df
read_t				=	~$bf
read_x				=	~$7f

;row #4
read_7				=	~$fe
read_y				=	~$fd
read_g				=	~$fb
read_8				=	~$f7
read_b				=	~$ef
read_h				=	~$df
read_u				=	~$bf
read_v				=	~$7f

;row #5
read_9				=	~$fe
read_i				=	~$fd
read_j				=	~$fb
read_0				=	~$f7
read_m				=	~$ef
read_k				=	~$df
read_o				=	~$bf
read_n				=	~$7f

;row #6
read_plus			=	~$fe
read_p				=	~$fd
read_l				=	~$fb
read_minus			=	~$f7
read_full_stop		=	~$ef
read_colon			=	~$df
read_at				=	~$bf
read_coma			=	~$7f

;row #7
read_pound			=	~$fe
read_star			=	~$fd
read_semi_colon		=	~$fb
read_clr_home		=	~$f7
read_right_shift	=	~$ef
read_equal			=	~$df
read_arrow_up		=	~$bf
read_divide			=	~$7f

;row #8
read_1				=	~$fe
read_arrow_left		=	~$fd
read_control		=	~$fb
read_2				=	~$f7
read_space			=	~$ef
read_cbm			=	~$df
read_q				=	~$bf
read_stop			=	~$7f

